
#ifndef exp1SetSTUDY_H_
#define exp1SetSTUDY_H_

#include "Reward/MTT_emotor/MTT_emotorPVNodes.h"
#include "Reward/MTT_emotor/MTT_emotorPVModel.h"
#include "Cpp/Study/BaseStudyClass.hpp"

extern double AttackRate;
extern short CC_enabler;
extern double CC_failure_rate;
extern double C_Att_Success;
extern double C_Rep_Success;
extern double C_fail_det_prob;
extern double Config_repair_success;
extern double Configuration_validation_Duration;
extern double ControlConfAttack;
extern double D_T_attack_prob;
extern double SS_Conf_Attack;
extern double SS_repair_rate;
extern double T_V_Offset_mean;
extern double T_V_Offset_stddev;
extern double T_V_step_interval_mean;
extern short T_V_steps_max;
extern short T_V_steps_min;
extern double TorqueAttack;
extern double USF_repair_rate;
extern double attack_CH1_success_pr;
extern double attack_CH2_success_pr;
extern short attack_count;
extern double channel_failure_rate;
extern double failure_coverage;
extern short single_SS_enabler_is_0;
extern double t_delta;
extern double t_window;
extern double torque_req_rate;
extern double v_delta;

class exp1SetStudy : public BaseStudyClass {
public:

exp1SetStudy();
~exp1SetStudy();

private:

double *AttackRateValues;
short *CC_enablerValues;
double *CC_failure_rateValues;
double *C_Att_SuccessValues;
double *C_Rep_SuccessValues;
double *C_fail_det_probValues;
double *Config_repair_successValues;
double *Configuration_validation_DurationValues;
double *ControlConfAttackValues;
double *D_T_attack_probValues;
double *SS_Conf_AttackValues;
double *SS_repair_rateValues;
double *T_V_Offset_meanValues;
double *T_V_Offset_stddevValues;
double *T_V_step_interval_meanValues;
short *T_V_steps_maxValues;
short *T_V_steps_minValues;
double *TorqueAttackValues;
double *USF_repair_rateValues;
double *attack_CH1_success_prValues;
double *attack_CH2_success_prValues;
short *attack_countValues;
double *channel_failure_rateValues;
double *failure_coverageValues;
short *single_SS_enabler_is_0Values;
double *t_deltaValues;
double *t_windowValues;
double *torque_req_rateValues;
double *v_deltaValues;

void SetValues_AttackRate();
void SetValues_CC_enabler();
void SetValues_CC_failure_rate();
void SetValues_C_Att_Success();
void SetValues_C_Rep_Success();
void SetValues_C_fail_det_prob();
void SetValues_Config_repair_success();
void SetValues_Configuration_validation_Duration();
void SetValues_ControlConfAttack();
void SetValues_D_T_attack_prob();
void SetValues_SS_Conf_Attack();
void SetValues_SS_repair_rate();
void SetValues_T_V_Offset_mean();
void SetValues_T_V_Offset_stddev();
void SetValues_T_V_step_interval_mean();
void SetValues_T_V_steps_max();
void SetValues_T_V_steps_min();
void SetValues_TorqueAttack();
void SetValues_USF_repair_rate();
void SetValues_attack_CH1_success_pr();
void SetValues_attack_CH2_success_pr();
void SetValues_attack_count();
void SetValues_channel_failure_rate();
void SetValues_failure_coverage();
void SetValues_single_SS_enabler_is_0();
void SetValues_t_delta();
void SetValues_t_window();
void SetValues_torque_req_rate();
void SetValues_v_delta();

void PrintGlobalValues(int);
void *GetGVValue(char *TheGVName);
void OverrideGVValue(char *TheGVName, void *TheGVValue);
void SetGVs(int expnum);
PVModel *GetPVModel(bool expandTimeArrays);
};

#endif

