#include "Composed/Div_SW/Div_SWRJ__Channel_2.h"
char * Div_SWRJ__Channel_2__SharedNames[] = {"Attack_enabled", "CCF_active", "CH2_OK", "CH2_Safe_state", "C_attack_enabled", "Channel_attacked_ID", "ConfigurationOK", "System_OK", "Unsafe_state_2"};

Div_SWRJ__Channel_2::Div_SWRJ__Channel_2():Join("Channel_2", 3, 9,Div_SWRJ__Channel_2__SharedNames) {
  SW_channel_2 = new SW_channelSAN();
  ModelArray[0] = (BaseModelClass*) SW_channel_2;
  ModelArray[0]->DefineName("SW_channel_2");
  configuration_channel_2 = new configuration_channelSAN();
  ModelArray[1] = (BaseModelClass*) configuration_channel_2;
  ModelArray[1]->DefineName("configuration_channel_2");
  Control_conf_channel_2 = new Control_configuration_channelSAN();
  ModelArray[2] = (BaseModelClass*) Control_conf_channel_2;
  ModelArray[2]->DefineName("Control_conf_channel_2");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    Attack_enabled = new Place("Attack_enabled");
    addSharedPtr(Attack_enabled, "Attack_enabled" );
    if (configuration_channel_2->NumStateVariables > 0) {
      Attack_enabled->ShareWith(configuration_channel_2->Attack_in_progress);
      addSharingInfo(configuration_channel_2->Attack_in_progress, Attack_enabled, configuration_channel_2);
    }

    //Shared variable 1
    CCF_active = new Place("CCF_active");
    addSharedPtr(CCF_active, "CCF_active" );
    if (SW_channel_2->NumStateVariables > 0) {
      CCF_active->ShareWith(SW_channel_2->CCF_active);
      addSharingInfo(SW_channel_2->CCF_active, CCF_active, SW_channel_2);
    }

    //Shared variable 2
    CH2_OK = new Place("CH2_OK");
    addSharedPtr(CH2_OK, "CH2_OK" );
    if (SW_channel_2->NumStateVariables > 0) {
      CH2_OK->ShareWith(SW_channel_2->Channel_OK);
      addSharingInfo(SW_channel_2->Channel_OK, CH2_OK, SW_channel_2);
    }
    if (Control_conf_channel_2->NumStateVariables > 0) {
      CH2_OK->ShareWith(Control_conf_channel_2->OK_state);
      addSharingInfo(Control_conf_channel_2->OK_state, CH2_OK, Control_conf_channel_2);
    }

    //Shared variable 3
    CH2_Safe_state = new Place("CH2_Safe_state");
    addSharedPtr(CH2_Safe_state, "CH2_Safe_state" );
    if (SW_channel_2->NumStateVariables > 0) {
      CH2_Safe_state->ShareWith(SW_channel_2->Safe_state);
      addSharingInfo(SW_channel_2->Safe_state, CH2_Safe_state, SW_channel_2);
    }
    if (Control_conf_channel_2->NumStateVariables > 0) {
      CH2_Safe_state->ShareWith(Control_conf_channel_2->Safe_failure);
      addSharingInfo(Control_conf_channel_2->Safe_failure, CH2_Safe_state, Control_conf_channel_2);
    }

    //Shared variable 4
    C_attack_enabled = new Place("C_attack_enabled");
    addSharedPtr(C_attack_enabled, "C_attack_enabled" );
    if (Control_conf_channel_2->NumStateVariables > 0) {
      C_attack_enabled->ShareWith(Control_conf_channel_2->Attack_in_progress);
      addSharingInfo(Control_conf_channel_2->Attack_in_progress, C_attack_enabled, Control_conf_channel_2);
    }

    //Shared variable 5
    Channel_attacked_ID = new Place("Channel_attacked_ID");
    addSharedPtr(Channel_attacked_ID, "Channel_attacked_ID" );
    if (configuration_channel_2->NumStateVariables > 0) {
      Channel_attacked_ID->ShareWith(configuration_channel_2->Channel_attacked_ID);
      addSharingInfo(configuration_channel_2->Channel_attacked_ID, Channel_attacked_ID, configuration_channel_2);
    }

    //Shared variable 6
    ConfigurationOK = new Place("ConfigurationOK");
    addSharedPtr(ConfigurationOK, "ConfigurationOK" );
    if (SW_channel_2->NumStateVariables > 0) {
      ConfigurationOK->ShareWith(SW_channel_2->Configuration_state);
      addSharingInfo(SW_channel_2->Configuration_state, ConfigurationOK, SW_channel_2);
    }
    if (configuration_channel_2->NumStateVariables > 0) {
      ConfigurationOK->ShareWith(configuration_channel_2->Correct);
      addSharingInfo(configuration_channel_2->Correct, ConfigurationOK, configuration_channel_2);
    }
    if (Control_conf_channel_2->NumStateVariables > 0) {
      ConfigurationOK->ShareWith(Control_conf_channel_2->Configuration_state);
      addSharingInfo(Control_conf_channel_2->Configuration_state, ConfigurationOK, Control_conf_channel_2);
    }

    //Shared variable 7
    System_OK = new Place("System_OK");
    addSharedPtr(System_OK, "System_OK" );
    if (SW_channel_2->NumStateVariables > 0) {
      System_OK->ShareWith(SW_channel_2->System_OK);
      addSharingInfo(SW_channel_2->System_OK, System_OK, SW_channel_2);
    }

    //Shared variable 8
    Unsafe_state_2 = new Place("Unsafe_state_2");
    addSharedPtr(Unsafe_state_2, "Unsafe_state_2" );
    if (SW_channel_2->NumStateVariables > 0) {
      Unsafe_state_2->ShareWith(SW_channel_2->Unsafe_state_2);
      addSharingInfo(SW_channel_2->Unsafe_state_2, Unsafe_state_2, SW_channel_2);
    }
    if (Control_conf_channel_2->NumStateVariables > 0) {
      Unsafe_state_2->ShareWith(Control_conf_channel_2->Unsafe_state_2);
      addSharingInfo(Control_conf_channel_2->Unsafe_state_2, Unsafe_state_2, Control_conf_channel_2);
    }

  }

  Setup();
}

Div_SWRJ__Channel_2::~Div_SWRJ__Channel_2() {
  if (!AllChildrenEmpty()) {
    delete Attack_enabled;
    delete CCF_active;
    delete CH2_OK;
    delete CH2_Safe_state;
    delete C_attack_enabled;
    delete Channel_attacked_ID;
    delete ConfigurationOK;
    delete System_OK;
    delete Unsafe_state_2;
  }
  delete SW_channel_2;
  delete configuration_channel_2;
  delete Control_conf_channel_2;
}
